VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "GDI+ Samples"
   ClientHeight    =   5055
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   6915
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5055
   ScaleWidth      =   6915
   StartUpPosition =   2  'CenterScreen
   Begin VB.ComboBox cboBkg 
      Enabled         =   0   'False
      Height          =   315
      ItemData        =   "frmMain.frx":0000
      Left            =   2880
      List            =   "frmMain.frx":00A6
      Style           =   2  'Dropdown List
      TabIndex        =   4
      Top             =   4725
      Width           =   3945
   End
   Begin MSComDlg.CommonDialog cmnDlg 
      Left            =   6270
      Top             =   3900
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
   End
   Begin VB.ComboBox cboSample 
      Height          =   315
      Left            =   2910
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   105
      Width           =   3885
   End
   Begin VB.TextBox txtInfo 
      Height          =   2490
      Left            =   75
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Top             =   2535
      Width           =   2760
   End
   Begin VB.PictureBox Picture1 
      Height          =   3900
      Left            =   2895
      ScaleHeight     =   3840
      ScaleWidth      =   3840
      TabIndex        =   1
      Top             =   495
      Width           =   3900
      Begin VB.Timer Timer1 
         Left            =   60
         Top             =   3360
      End
   End
   Begin VB.ListBox lstExamples 
      Height          =   2400
      ItemData        =   "frmMain.frx":05E5
      Left            =   75
      List            =   "frmMain.frx":060D
      TabIndex        =   0
      Top             =   105
      Width           =   2760
   End
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Caption         =   "^^ Dbl Click above for image details"
      Height          =   285
      Left            =   2895
      TabIndex        =   5
      Top             =   4440
      Width           =   3960
   End
   Begin VB.Menu mnuPop 
      Caption         =   "dummy"
      Visible         =   0   'False
      Begin VB.Menu mnuPopup 
         Caption         =   "Display Image #1"
         Index           =   0
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim msgPlgBltRotationShown As Boolean ' whether message was shown or not. See DoPLYBLTExample routine below
Dim cGDIplus As cGDIpToken  ' should be made available to entire project. If multiple forms in project, place Public in module
Dim cImage As cGDIpImage    ' sample used throughout this form
Dim cGraphics As cGDIpRenderer ' can be created/destroyed as needed
Dim cBrushes As cGDIpPenBrush   ' can be created/destroyed as needed
Dim sampleCx As Long, sampleCy As Long ' rendering size (see RenderTheImage routine)
Dim sampleScalesUp As Boolean ' whether rendered sample can scale up or not (see RenderTheImage routine)

Private Sub Form_Load()
    Picture1.ScaleMode = vbPixels
    Picture1.AutoRedraw = True
    cboBkg.ListIndex = 0
    Me.Show
    
    ' validate user has GDI+ and setup classes for this sample project
    Set cGDIplus = New cGDIpToken
    If cGDIplus.Token = 0& Then
        lstExamples.Enabled = False
        cboSample.Enabled = False
        Picture1.Enabled = False
        MsgBox "Cannot run this project on your computer. GDI+ is required and it could not be loaded.", vbExclamation + vbOKOnly
    Else
        Set cImage = New cGDIpImage
        Set cGraphics = New cGDIpRenderer
        Set cBrushes = New cGDIpPenBrush
        cBrushes.AttachTokenClass cGDIplus
        cGraphics.AttachTokenClass cGDIplus
        cboBkg.Enabled = True

    ' start a preview sample, using animated GIF with rotation
        lstExamples.ListIndex = lstExamples.ListCount - 2
        cImage.Rotation = 45
        cboBkg.ListIndex = 5
        Call DoAnimatedGIFExample(0)
        cboSample.ListIndex = cboSample.ListCount - 1
        Picture1.ToolTipText = "Right click to select different frame/page or to animate GIFs"

    End If
    
End Sub

Private Sub lstExamples_Click()

    Dim X As Long, bAnimate As Boolean
    
    bAnimate = Timer1.Enabled                       ' were we animating a GIF?
    Timer1.Enabled = False
    If cboBkg.Enabled = False Then
        Call cboBkg_Click ' was on gradient example, change back to custom bkg
        cboBkg.Enabled = True
    End If
    cboSample.Clear
    
    Select Case lstExamples.ListIndex
    Case 0 ' loading
        txtInfo.Text = "Images can be loaded from file (unicode supported), arrays, stdPictures, VB Picture properties and from DIB handles." & vbCrLf & _
            "To support unicode file names, you should use unicode version of the common dialog."
        cboSample.AddItem "Load From File"
        cboSample.AddItem "Load From Resource/Array"
        cboSample.AddItem "Load from stdPicture (form's Icon property)"
        cboSample.AddItem "Select a load option from the list"
        cboSample.SetFocus
        cboSample.ListIndex = cboSample.ListCount - 1&
        
    Case 1 ' saving
        txtInfo.Text = "Images can be saved with/without image attributes to the following formats: PNG, JPG, BMP, TIFF. Additionally, multiple images " & _
            "can be saved to a TIFF is a multi-page TIFF."
        cboSample.AddItem "Save as Bitmap"
        cboSample.AddItem "Save as JPEG"
        cboSample.AddItem "Save as PNG"
        cboSample.AddItem "Save as TIFF"
        cboSample.AddItem "Save MultiPage TIFF example"
        cboSample.AddItem "Save Original Format"
        cboSample.AddItem "Select a save option from the list"
        cboSample.SetFocus
        cboSample.ListIndex = cboSample.ListCount - 1&
        
    Case 2: ' scaling
        txtInfo.Text = "GDI+ can produce really sharp images when they are scaled and rotated." & vbCrLf & _
            "The example here will scale from 256 to 16 and back to 256."
        For X = 16 To 256 Step 16
            cboSample.AddItem "Scale to " & X & " x " & X
            cboSample.ItemData(cboSample.newIndex) = X
        Next
        sampleCx = Picture1.ScaleWidth
        sampleCy = Picture1.ScaleHeight
        cboSample.SetFocus
        cboSample.ListIndex = cboSample.ListCount - 1&
        
    Case 3: ' grayscaling
        txtInfo.Text = "GDI+ allows you to grayscale without modifying the original image data. This grayscaling on the fly is a simple matter of using image attribute objects." & vbCrLf & _
            "There are eight different grayscale ratios for you to choose from."
        cboSample.AddItem "No Grayscaling"
        cboSample.AddItem "SimpleAverage"
        cboSample.AddItem "NTSCPAL"
        cboSample.AddItem "CCIR709"
        cboSample.AddItem "RedMask"
        cboSample.AddItem "GreenMask"
        cboSample.AddItem "BlueMask"
        cboSample.AddItem "GrayBlueGreenMask"
        cboSample.AddItem "GrayRedGreenMask"
        cboSample.SetFocus
        cboSample.ListIndex = cImage.GrayScale
            
    
    Case 4 ' light add/removal
        txtInfo.Text = "GDI+ allows you to modify pixel information without modifying the original data." & vbCrLf & "You can choose between -100 to 100 percent lightness."
        For X = 100 To 10 Step -10
            cboSample.AddItem "Add " & X & " percent darkness"
        Next
        cboSample.AddItem "No additional darkness or lightness"
        For X = 10 To 100 Step 10
            cboSample.AddItem "Add " & X & " percent lightness"
        Next
        cboSample.SetFocus
        cboSample.ListIndex = (cImage.GlobalLightnessPct + 100) \ 10
        
    Case 5 ' Mirroring
        txtInfo.Text = "GDI+ has a niffty little function that lets you mirror and rotate at 90 degree intervals with a simple call."
        cboSample.AddItem "No Mirroring"
        cboSample.AddItem "Mirror Both Directions"
        cboSample.AddItem "Mirror Horizontally"
        cboSample.AddItem "Mirror Vertically"
        cboSample.SetFocus
        cboSample.ListIndex = cImage.Mirrored
        
    Case 6 ' Rotation
        txtInfo.Text = "GDI+ rotates images pretty quickly and with optional high quality interpolation, the results can be quite good." & vbCrLf & _
            "Rotation is always clockwise, but can be modified by simply providing negative degree values"
        For X = 0 To 360 Step 5
            cboSample.AddItem "Rotate to " & X & " degrees"
        Next
        cboSample.SetFocus
        cboSample.ListIndex = (cImage.Rotation \ 5)
        
    Case 7 ' Transparency
        txtInfo.Text = "GDI+ allows changing global transparency throughout the entire image via its image attributes object."
        For X = 0 To 100 Step 5
            cboSample.AddItem "Make " & 100 - X & " percent transparent"
        Next
        cboSample.SetFocus
        cboSample.ListIndex = (100 - cImage.GlobalTransparencyPct) \ 5
        
    Case 8 ' PolygonBLT
        txtInfo.Text = "GDI+ offers a polygon BLT function too."
        cboSample.Clear
        DoPLYBLTExample
        bAnimate = False
        
    Case 9 ' TransparentBLT
        txtInfo.Text = "GDI+ offers a way to render an image with a color transparent throughout, much like TransparentBLT API."
        cboSample.Clear
        DoTransBLTExample
        bAnimate = False
        
    Case 10 ' Multipage/frame (animated GIFs)
        txtInfo.Text = "GDI+ allows you to view each frame of an animated GIF or multipage TIF. Additionally, the classes allow you to view each icon/cursor in a multi-image resource." & vbCrLf & _
            "With animated GIFs and a simple timer, animating the images is a snap!"
        cboSample.SetFocus
        DoAnimatedGIFExample 0
    
    Case 11 ' brushes/gradients
        txtInfo.Text = "There are vast options for custom pens and brushes. This project shows a small number of examples."
        cboSample.AddItem "Diagonal Gradient"
        cboSample.AddItem "Vertical Gradient"
        cboSample.AddItem "Horizontal Gradient"
        cboSample.AddItem "Texture Brush - Tile"
        cboSample.ListIndex = 0
        cboSample.SetFocus
        cboBkg.Enabled = False
    
    End Select
    
    If bAnimate Then Timer1.Enabled = True
    
End Sub

Private Sub cboSample_Click()
    Select Case lstExamples.ListIndex
    Case 0: Call DoLoadExample
    Case 1: Call DoSaveExample
    Case 2: Call DoScalingExample
    Case 3: Call DoGrayScalingExample
    Case 4: Call DoLightnessExample
    Case 5: Call DoMirroringExample
    Case 6: Call DoRotationExample
    Case 7: Call DoTransparencyExample
    Case 10: Call DoAnimatedGIFExample(1)
    Case 11: Call DoGradientExample
    End Select
End Sub

Private Sub RenderTheImage()
    
    Dim X As Long, Y As Long, cX As Long, cY As Long
    
    cImage.GetScaledImageSizes sampleCx, sampleCy, cX, cY, sampleScalesUp
    X = (Picture1.ScaleWidth - cX) \ 2
    Y = (Picture1.ScaleHeight - cY) \ 2
    
    Picture1.Cls
    ' the higher the quality of graphics, the slower the rendering. There are 3 other quality parameters available
    cGraphics.RenderImageClassToDC cImage, Picture1.hDC, X, Y, cX, cY, , , , , InterpolationModeHighQualityBicubic
    Picture1.Refresh
End Sub

Private Sub LoadResourceImage(resName As String)
    
    Dim bData() As Byte
    bData = LoadResData(resName, "Custom")
    Call cImage.LoadPicture_Stream(bData, cGDIplus)
    sampleCx = Picture1.ScaleWidth
    sampleCy = Picture1.ScaleHeight
    sampleScalesUp = False

End Sub

Private Sub DoAnimatedGIFExample(Index As Integer)

    Dim X As Long
    Timer1.Enabled = False
    If Index = 0 Then
        ' supply animated gif if not one is selected
        If cImage.Handle Then
            If cImage.ImageType <> imageGIF Then
                cImage.Clear
            ElseIf cImage.MultiImageInfo.Count < 2 Then
                cImage.Clear
            End If
        End If
        If cImage.Handle = 0 Then LoadResourceImage "ANIGIF"
        cboSample.Clear
        For X = 0 To cImage.MultiImageInfo.Count - 1
            cboSample.AddItem "Frame " & X + 1
        Next
        If cImage.MultiImageInfo.Count > 1 Then cboSample.AddItem "Animate the GIF"
        cboSample.ListIndex = cImage.MultiImageInfo.Index
    Else
        If cboSample.ListIndex = cboSample.ListCount - 1& Or Index = 2 Then
            Timer1.Enabled = False
            Timer1.Interval = cImage.MultiImageInfo.GifFrameDelay(cImage.MultiImageInfo.Index)
            RenderTheImage
            Timer1.Enabled = True
        Else
            cImage.MultiImageInfo.Index = cboSample.ListIndex
            RenderTheImage
        End If
    End If
    
End Sub

Private Sub DoGradientExample()

    Dim hBrush As Long, hGraphics As Long, bData() As Byte, cTile As cGDIpImage
    Dim bAnimate As Boolean
    
    If Timer1.Enabled Then
        bAnimate = True
        Timer1.Enabled = False
    End If
    
    Picture1.Cls
    Select Case cboSample.ListIndex
    Case 0
        hBrush = cBrushes.CreateGradientLineBrush(0, 0, Picture1.ScaleWidth, Picture1.ScaleHeight, cBrushes.RGBtoARGB(vbCyan), cBrushes.RGBtoARGB(vbBlue), WrapModeTile)
    Case 1
        hBrush = cBrushes.CreateGradientLineBrush(Picture1.ScaleWidth \ 2, 0, Picture1.ScaleWidth \ 2, Picture1.ScaleHeight, cBrushes.RGBtoARGB(vbCyan), cBrushes.RGBtoARGB(vbBlue), WrapModeTile)
    Case 2
        hBrush = cBrushes.CreateGradientLineBrush(0, Picture1.ScaleHeight \ 2, Picture1.ScaleWidth, Picture1.ScaleHeight \ 2, cBrushes.RGBtoARGB(vbCyan), cBrushes.RGBtoARGB(vbBlue), WrapModeTile)
    Case 3
        Set cTile = New cGDIpImage
        bData = LoadResData("TILE", "Custom")
        Call cTile.LoadPicture_Stream(bData, cGDIplus)
        hBrush = cBrushes.CreateBrushFromImage(cTile)
    End Select
    
    hGraphics = cGraphics.CreateHGraphicsFromHDC(Picture1.hDC)
    cGraphics.DrawRectangle hGraphics, 0, 0, Picture1.ScaleWidth, Picture1.ScaleHeight, , , hBrush
    cBrushes.DestroyBrush hBrush
    cGraphics.DestroyHGraphics hGraphics
    Set Picture1.Picture = Picture1.Image
    RenderTheImage
    Timer1.Enabled = bAnimate
End Sub

Private Sub DoPLYBLTExample()

    If cImage.Handle = 0& Then LoadResourceImage "Spider"
    Picture1.Cls
    cGraphics.PlgBltImageClassToDC cImage, _
        Picture1.hDC, Picture1.ScaleWidth \ 3, Picture1.ScaleHeight \ 3, _
        Picture1.ScaleWidth, Picture1.ScaleHeight \ 2, _
        0, Picture1.ScaleHeight \ 2, , , , , InterpolationModeHighQualityBicubic, SmoothingModeAntiAlias, , , &H40FFFFFF
    Picture1.Refresh
    If cImage.Rotation Then
        If msgPlgBltRotationShown = False Then
            MsgBox "Rotation is not rendered with PolygonBLT", vbInformation + vbOKOnly
            msgPlgBltRotationShown = True
        End If
    End If

End Sub

Private Sub DoTransBLTExample()

    cImage.LoadPicture_stdPicture LoadResPicture("FOX", vbResBitmap), cGDIplus
    sampleCx = Picture1.ScaleWidth
    sampleCy = Picture1.ScaleHeight
    sampleScalesUp = False
    RenderTheImage
    MsgBox "The background of the image will be replaced with transparency only when rendering; image is not modified." & vbCrLf & vbCrLf & _
        "You may need to move this message box out of the way to see the image", vbInformation + vbOKOnly
    cImage.ExtraTransparentColor = cImage.GetPixel(0, 0)
    RenderTheImage
    
End Sub

Private Sub DoTransparencyExample()

    If cImage.Handle = 0& Then LoadResourceImage "Spider"
    cImage.GlobalTransparencyPct = 100 - (cboSample.ListIndex * 5)
    RenderTheImage

End Sub

Private Sub DoMirroringExample()

    If cImage.Handle = 0& Then LoadResourceImage "Spider"
    cImage.Mirrored = cboSample.ListIndex
    RenderTheImage

End Sub

Private Sub DoRotationExample()

    If cImage.Handle = 0& Then LoadResourceImage "Spider"
    cImage.Rotation = cboSample.ListIndex * 5
    RenderTheImage

End Sub

Private Sub DoLightnessExample()

    If cImage.Handle = 0& Then LoadResourceImage "Spider"
    cImage.GlobalLightnessPct = cboSample.ListIndex * 10 - 100
    RenderTheImage

End Sub

Private Sub DoGrayScalingExample()

    If cImage.Handle = 0& Then LoadResourceImage "Spider"
    cImage.GrayScale = cboSample.ListIndex
    RenderTheImage

End Sub

Private Sub DoScalingExample()

    If cImage.Handle = 0& Then
        LoadResourceImage "Spider"
    Else
        sampleCx = cboSample.ItemData(cboSample.ListIndex)
        sampleCy = sampleCx
    End If
    sampleScalesUp = True
    RenderTheImage
    
End Sub

Private Sub DoSaveExample()

    If cImage.Handle = 0& Then
        MsgBox "First select an image to be displayed", vbInformation + vbOKOnly
        Exit Sub
    ElseIf cboSample.ListIndex = cboSample.ListCount - 1& Then
        Exit Sub
    End If
    
    Dim bData() As Byte, fn As Integer, bOk As Boolean
    Dim tImage() As cGDIpImage ' << multipage tiff example
    
    If Timer1.Enabled Then
        Timer1.Enabled = False
        cImage.MultiImageInfo.Index = 0
    End If
    
    With cmnDlg
        .DialogTitle = "Save File As"
        .Flags = cdlOFNExplorer Or cdlOFNPathMustExist Or cdlOFNOverwritePrompt
        Select Case cboSample.ListIndex
            Case 0: .Filter = "Bitmaps|*.bmp"
                .DefaultExt = "bmp"
            Case 1: .Filter = "JPEGs|*.jpg;*.jpeg"
                .DefaultExt = ".jpg"
            Case 2: .Filter = "PNGs|*.png"
                .DefaultExt = "png"
            Case 3, 4: .Filter = "TIFFs|*.tif;*.tiff"
                .DefaultExt = "tif"
            Case 5 ' save original format
                Select Case cImage.ImageType
                    Case imageBitmap: .Filter = "Bitmaps|*.bmp"
                        .DefaultExt = "bmp"
                    Case imageEMF: .Filter = "Extended MetaFile|*.emf"
                        .DefaultExt = "emf"
                    Case imageGIF: .Filter = "GIF|*.gif"
                        .DefaultExt = "gif"
                    Case imageIcon: .Filter = "Icon|*.ico"
                        .DefaultExt = "ico"
                    Case imageCursor: .Filter = "Cursor|*.cur"
                        .DefaultExt = "cur"
                    Case imageJPEG: .Filter = "JPEG|*.jpg"
                        .DefaultExt = "jpg"
                    Case imagePNG:  .Filter = "PNG|*.png"
                        .DefaultExt = "png"
                    Case imageTIFF: .Filter = "TIFF|*.tif"
                        .DefaultExt = "tif"
                    Case imageWMF: .Filter = "Windows MetaFile|*.wmf"
                        .DefaultExt = "wmf"
                    Case Else:  .Filter = "Unknown|*.*"
                        .DefaultExt = ""
                End Select
        End Select
    End With
    On Error GoTo ExitRoutine
    cmnDlg.ShowSave
    ' here we are going to save as drawn, simply opting for the last parameter as true
    ' Though you cannot save the file to a different size directly, you can by calling
    ' another function first....
    '   Example:
    '        Dim newImage As cGDIpImage
    '        cImage.CloneImage newImage, newWidth, newHeight, True
    '        newImage.SaveAsPNG bData()
            
    Select Case cboSample.ListIndex
        Case 0: bOk = cImage.SaveAsBMP(bData(), True)
        Case 1: bOk = cImage.SaveAsJPG(bData(), , True)
        Case 2: bOk = cImage.SaveAsPNG(bData(), True)
        Case 3: bOk = cImage.SaveAsTIFF(bData(), , , , True)
        Case 4: ' multipage tiff example
            ReDim tImage(0 To 2) As cGDIpImage                          ' 32 bit image
            Set tImage(0) = New cGDIpImage
            bData() = LoadResData("Spider", "Custom")
            Call tImage(0).LoadPicture_Stream(bData(), cGDIplus)
                
                Set tImage(1) = New cGDIpImage                          ' 24 bit image
                bData() = LoadResData("24BPP", "Custom")
                Call tImage(1).LoadPicture_Stream(bData(), cGDIplus)
            
            Set tImage(2) = New cGDIpImage                              ' 4 bit image
            bData() = LoadResData("TILE", "Custom")
            Call tImage(2).LoadPicture_Stream(bData(), cGDIplus)
            bOk = cImage.SaveAsTIFF(bData(), tImage())
        Case 5: bOk = cImage.SaveAsOriginalFormat(bData)
    End Select
    If bOk = False Then
        MsgBox "Failed to save to the desired image format", vbInformation + vbOKOnly
    Else
        fn = FreeFile()
        Open cmnDlg.FileName For Binary As #fn
        Put #fn, 1, bData()
        Close #fn
        If cboSample.ListIndex = 4 Then
            MsgBox "The TIFF saved contains 3 images: 32bit PNG, 24bit RGB Bitmap, 4bit Bitmap"
        Else
            MsgBox "File saved", vbInformation + vbOKOnly
        End If
    End If

ExitRoutine:
    If fn Then
        Close #fn
        If Err Then MsgBox Err.Description, vbExclamation + vbOKOnly
    End If
End Sub

Private Sub DoLoadExample()
    
    Dim bData() As Byte
    
    If Timer1.Enabled Then Timer1.Enabled = False
    
    sampleCx = Picture1.ScaleWidth
    sampleCy = Picture1.ScaleHeight
    sampleScalesUp = False
    
    Select Case cboSample.ListIndex
    Case 0: ' load from file
        With cmnDlg
            .DialogTitle = "Select Image File"
            .Flags = cdlOFNExplorer Or cdlOFNFileMustExist
            .Filter = "Supported Formats|*.bmp;*.ico;*.cur;*.jpg;*.jpeg;*.wmf;*.emf;*.png;*.tif;*.tiff;*.gif|" & _
                "Bitmaps|*.bmp|" & _
                "Icons/Cursors|*.ico;*.cur|" & _
                "GIFs|*.gif|" & _
                "JPEGs|*.jpg;*.jpeg|" & _
                "MetaFiles|*.wmf;*.emf|" & _
                "PNGs|*.png|" & _
                "TIFFs|*.tif;*.tiff|" & _
                "All Files|*.*"
        End With
        On Error GoTo ExitRoutine
        cmnDlg.ShowOpen
        If cImage.LoadPicture_FileName(cmnDlg.FileName, cGDIplus) = False Then
            MsgBox "Failed to load that image file", vbInformation + vbOKOnly
            Exit Sub
        End If
    Case 1 ' load from array/resource
        If (Second(Now()) And 1) Then
            bData = LoadResData("PARGB", "Custom")
        Else
            bData = LoadResData("ARGB", "Custom")
        End If
        If cImage.LoadPicture_Stream(bData, cGDIplus) = False Then
            MsgBox "Failed to load image data from resource", vbInformation + vbOKOnly
            Exit Sub
        End If
    Case 2 ' load from stdPicture
        If cImage.LoadPicture_stdPicture(Me.Icon, cGDIplus) = False Then
            MsgBox "Failed to load the form's icon", vbInformation + vbOKOnly
            Exit Sub
        End If
    Case Else: Exit Sub
    End Select
    
    Call RenderTheImage
    If cImage.MultiImageInfo.Count > 1& Then
        ' set minimal frame delay for frames if any are less than 30ms. Note: Many gifs have 0 for the delay
        ' FYI: The GifMinimumFrameDelay is defaulted to 10 in the class
        Picture1.ToolTipText = "Right click to select different frame/page or to animate GIFs"
        MsgBox "This image has " & cImage.MultiImageInfo.Count & " images contained." & vbCrLf & "Each can be displayed individually. Right click on the image.", vbInformation + vbOKOnly
        If cImage.ImageType = imageGIF Then
            cImage.MultiImageInfo.GifMinimumFrameDelay = 30&
            DoAnimatedGIFExample 2
        End If
    Else
        Picture1.ToolTipText = vbNullString
    End If

ExitRoutine:
End Sub

Private Sub cboBkg_Click()
    If cboBkg.ListIndex = 0 Then
        Set Picture1.Picture = Nothing
    Else
        Dim hBrush As Long, hGraphics As Long
        Picture1.Cls
        hBrush = cBrushes.CreateHatchBrush(cboBkg.ListIndex - 1, cBrushes.RGBtoARGB(vbCyan), cBrushes.RGBtoARGB(RGB(160, 160, 255)))
        hGraphics = cGraphics.CreateHGraphicsFromHDC(Picture1.hDC)
        cGraphics.DrawRectangle hGraphics, 0, 0, Picture1.ScaleWidth, Picture1.ScaleHeight, , , hBrush
        cBrushes.DestroyBrush hBrush
        cGraphics.DestroyHGraphics hGraphics
        Set Picture1.Picture = Picture1.Image
    End If
    If Not cImage Is Nothing Then
        If cImage.Handle Then
            If lstExamples.ListIndex = 8 Then ' plgblt
                Call lstExamples_Click
            Else
                RenderTheImage
            End If
        End If
    End If
End Sub

Private Sub mnuPopup_Click(Index As Integer)
    If mnuPopup(Index).Checked = False Then
        Timer1.Enabled = False
        If mnuPopup(Index).Caption = "Animate the GIF" Then
            DoAnimatedGIFExample 2
        Else
            cImage.MultiImageInfo.Index = Index
            RenderTheImage
        End If
    End If
End Sub

Private Sub Picture1_DblClick()
    If cImage.Handle = 0 Then
        MsgBox "No image loaded", vbInformation + vbOKOnly
        
    ElseIf lstExamples.ListIndex < lstExamples.ListCount - 1 Then
        Dim sInfo As String, gifPalette() As Long, gifTransIndex As Long
        Select Case cImage.ImageType
            Case imageBitmap: sInfo = "Image Type: Bitmap"
            Case imageCursor: sInfo = "Image Type: Cursor"
            Case imageCursorPNG: sInfo = "Image Type: Cursor in PNG format"
            Case imageEMF: sInfo = "Image Type: Extended MetaFile"
            Case imageGIF
                If cImage.MultiImageInfo.Count > 1 Then
                    sInfo = "Image Type: Animated GIF"
                Else
                    sInfo = "Image Type: GIF"
                End If
            Case imageIcon: sInfo = "Image Type: Icon"
            Case imageIconPNG: sInfo = "Image Type: Icon in PNG format"
            Case imageJPEG: sInfo = "Image Type: JPEG"
            Case imagePNG: sInfo = "Image Type: PNG"
            Case imageTIFF
                If cImage.MultiImageInfo.Count > 1 Then
                    sInfo = "Image Type: Multi-Page TIFF"
                Else
                    sInfo = "Image Type: TIFF"
                End If
            Case imageWMF: sInfo = "Image Type: Windows MetaFile"
            Case Else: sInfo = "Image Type: Unknown"
        End Select
        sInfo = sInfo & vbCrLf & "Size: " & cImage.Width & " x " & cImage.Height & vbCrLf
        Select Case cImage.ColorFormat
            Case PixelFormat16bppARGB1555: sInfo = sInfo & "Color Type: 16 bit + Alpha"
            Case PixelFormat16bppGrayScale: sInfo = sInfo & "Color Type: 16 bit GrayScaled"
            Case PixelFormat16bppRGB555: sInfo = sInfo & "Color Type: 16 bit + 555 format"
            Case PixelFormat16bppRGB565: sInfo = sInfo & "Color Type: 16 bit + 565 format"
            Case PixelFormat1bppIndexed: sInfo = sInfo & "Color Type: 1 bit, 2 colors"
            Case PixelFormat24bppRGB: sInfo = sInfo & "Color Type: 24 bit True Color"
            Case PixelFormat32bppARGB: sInfo = sInfo & "Color Type: True Color + Alpha"
            Case PixelFormat32bppPARGB: sInfo = sInfo & "Color Type: True Color + Premultiplied Alpha"
            Case PixelFormat32bppRGB: sInfo = sInfo & "Color Type: 32 bit True Color no Alpha"
            Case PixelFormat48bppRGB: sInfo = sInfo & "Color Type: 48 bit"
            Case PixelFormat4bppIndexed: sInfo = sInfo & "Color Type: 4 bit, 16 colors"
            Case PixelFormat64bppARGB: sInfo = sInfo & "Color Type: 64 bit + Alpha"
            Case PixelFormat64bppPARGB: sInfo = sInfo & "Color Type: 64 bit + Premultiplied Alpha"
            Case PixelFormat8bppIndexed: sInfo = sInfo & "Color Type: 8 bit, 256 colors"
            Case Else: sInfo = sInfo & "Color Type: Unknown"
        End Select
        If cImage.ImageType = imageGIF Then
            If cImage.MultiImageInfo.GetGifFramePalette(gifPalette(), gifTransIndex) = True Then
                If gifTransIndex = -1& Then
                    sInfo = sInfo & vbCrLf & "No transparency used"
                Else
                    sInfo = sInfo & vbCrLf & "Palette transparency Index is " & gifTransIndex
                End If
            End If
            If cImage.MultiImageInfo.Count > 1 Then
                If cImage.MultiImageInfo.GetGifLoopCount = 0 Then
                    sInfo = sInfo & vbCrLf & "Should loop indefinitely"
                Else
                    sInfo = sInfo & vbCrLf & "Stop looping after " & cImage.MultiImageInfo.GetGifLoopCount & " cycles"
                End If
                If Timer1.Enabled = True Then
                    sInfo = sInfo & vbCrLf & vbCrLf & "While uncompiled, VB timers stop when modal windows are displayed, so animation is paused too."
                End If
            End If
        End If
        MsgBox sInfo, vbOKOnly, "Image Information"
    End If
    
End Sub

Private Sub Picture1_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = vbRightButton Then
        If cImage.MultiImageInfo.Count > 1 Then
            Dim Index As Integer, sType As String
            For Index = mnuPopup.UBound To 1 Step -1
                Unload mnuPopup(Index)
            Next
            If cImage.ImageType = imageGIF Then
                sType = "Show GIF Frame # "
            ElseIf cImage.ImageType = imageTIFF Then
                sType = "Show TIFF Page # "
            Else ' must be icon/cursor
                sType = "Show Icon # "
            End If
            mnuPopup(0).Checked = False
            For Index = 2 To cImage.MultiImageInfo.Count
                Load mnuPopup(Index - 1)
                mnuPopup(Index - 1).Caption = sType & CStr(Index)
            Next
            If cImage.ImageType = imageGIF Then
                Load mnuPopup(Index - 1)
                mnuPopup(Index - 1).Caption = "Animate the GIF"
            End If
            mnuPopup(0).Caption = sType & "1"
            mnuPopup(cImage.MultiImageInfo.Index).Checked = True
            PopupMenu mnuPop
        End If
    End If
End Sub

Private Sub Timer1_Timer()
    Timer1.Enabled = False
    cImage.MultiImageInfo.MoveNext
    Timer1.Interval = cImage.MultiImageInfo.GifFrameDelay(cImage.MultiImageInfo.Index)
    RenderTheImage
    Timer1.Enabled = True
    ' note about the GifFrameDelay values...
    ' set minimal frame delay for frames if any are less than 30. Note: Many gifs have 0 for the delay
    ' FYI: The GifMinimumFrameDelay is defaulted to 10 in the class & a sample call might look like:
    '   >> If cImage.ImageType = imageGIF Then cImage.MultiImageInfo.GifMinimumFrameDelay = 30&
    
End Sub
